Ginkgo: gko::factorization::Ilu< ValueType, IndexType > Class Template Reference

| Ginkgo Generated from branch based on main. Ginkgo version 1.11.0 A numerical linear algebra library targeting many-core architectures

Loading...
Searching...
No Matches
gko::factorization::Ilu< ValueType, IndexType > Class Template Reference
Linear Operators » Factorizations | Linear Operators

Represents an incomplete LU factorization – ILU(0) – of a sparse matrix. More...

`#include <ginkgo/core/factorization/ilu.hpp>`

Inheritance diagram for gko::factorization::Ilu< ValueType, IndexType >:
[legend]
Collaboration diagram for gko::factorization::Ilu< ValueType, IndexType >:
[legend]

## Classes
struct | parameters_type
class | Factory

## Public Types
using | value_type = ValueType
using | index_type = IndexType
using | matrix_type = matrix::Csr<ValueType, IndexType>
Public Types inherited from gko::Composition< gko::default_precision >
using | value_type
using | transposed_type
Public Types inherited from gko::EnablePolymorphicAssignment< Composition< gko::default_precision > >
using | result_type

## Public Member Functions
std::shared_ptr< const matrix_type > | get_l_factor () const
std::shared_ptr< const matrix_type > | get_u_factor () const
const parameters_type & | get_parameters () const
Public Member Functions inherited from gko::Composition< gko::default_precision >
const std::vector< std::shared_ptr< const LinOp > > & | get_operators () const noexcept
| Returns a list of operators of the composition.
std::unique_ptr< LinOp > | transpose () const override
| Returns a LinOp representing the transpose of the Transposable object.
std::unique_ptr< LinOp > | conj_transpose () const override
| Returns a LinOp representing the conjugate transpose of the Transposable object.
Composition & | operator= (const Composition &)
| Copy-assigns a Composition.
| Composition (const Composition &)
| Copy-constructs a Composition.
Public Member Functions inherited from gko::EnableLinOp< Composition< gko::default_precision > >
const Composition< gko::default_precision > * | apply (ptr_param< const LinOp > b, ptr_param< LinOp > x) const
Public Member Functions inherited from gko::EnablePolymorphicAssignment< Composition< gko::default_precision > >
void | convert_to (result_type *result) const override
void | move_to (result_type *result) override

## Static Public Member Functions
template<typename... Args>
static std::unique_ptr< Composition< ValueType > > | create (Args &&... args)=delete
static auto | build () -> decltype(Factory::create())
static parameters_type | parse (const config::pnode &config, const config::registry &context, const config::type_descriptor &td_for_child=config::make_type_descriptor< ValueType, IndexType >())
| Create the parameters from the property_tree.
Static Public Member Functions inherited from gko::EnableCreateMethod< Composition< gko::default_precision > >
static std::unique_ptr< Composition< gko::default_precision > > | create (Args &&... args)

## Detailed Description

template<typename ValueType = gko::default_precision, typename IndexType = gko::int32>
class gko::factorization::Ilu< ValueType, IndexType >

Represents an incomplete LU factorization – ILU(0) – of a sparse matrix.

More specifically, it consists of a lower unitriangular factor and an upper triangular factor with sparsity pattern = fulfilling at every non-zero location of .

Template Parameters

  ValueType | Type of the values of all matrices used in this class
  IndexType | Type of the indices of all matrices used in this class

## Member Function Documentation

## ◆ parse()

template<typename ValueType = gko::default_precision, typename IndexType = gko::int32>

parameters_type gko::factorization::Ilu< ValueType, IndexType >::parse | ( | const config::pnode & | config,
|  | const config::registry & | context,
|  | const config::type_descriptor & | td_for_child = config::make_type_descriptor< ValueType, IndexType >() )
| static

Create the parameters from the property_tree.

Because this is directly tied to the specific type, the value/index type settings within config are ignored and type_descriptor is only used for children configs.

Parameters

  config | the property tree for setting
  context | the registry
  td_for_child | the type descriptor for children configs. The default uses the value/index type of this class.

Returns
  parameters

References gko::Composition< gko::default_precision >::Composition().

The documentation for this class was generated from the following file:

- ginkgo/core/factorization/ilu.hpp